routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\BuyController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\StoreController;
use App\Http\Controllers\WalletController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\VoucherController;
use App\Http\Controllers\NotificationController;

/*
|--------------------------------------------------------------------------
| Web Routesfunction () { return view('home'); });nam
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//home
Route::get('/', [HomeController::class, 'home'])->name('home');

//Buy
Route::get('products/{product}/buy', [BuyController::class, 'buy'])->name('buy');
Route::post('products/{product}/buynow', [BuyController::class, 'buynow'])->name('buynow');

Route::group(['middleware' => 'auth'], function () {
    //Logout
    Route::get('logout', [AuthController::class, 'logout'])->name('logout');

    //Stores
    Route::resource('stores', StoreController::class);

    //Products
    Route::get('stores/{store}/products', [ProductController::class, 'index'])->name('products.index');
    Route::get('stores/{store}/products/create', [ProductController::class, 'create'])->name('products.create');
    Route::post('store/{store}/products/store', [ProductController::class, 'store'])->name('products.store');
    Route::get('stores/{store}/products/{product}/edit', [ProductController::class, 'edit'])->name('products.edit');
    Route::delete('store/{store}/products/{product}/delete', [ProductController::class, 'destroy'])->name('products.destroy');
    Route::get('stores/{store}/products/{product}/view', [ProductController::class, 'view'])->name('products.view');

    // Wallets
    Route::resource('wallets', WalletController::class)->only('show');

    // Voucher
    Route::get('stores/{store}/voucher', [VoucherController::class, 'index'])->name('vouchers.index');
    Route::get('stores/{store}/voucher/create', [VoucherController::class, 'create'])->name('vouchers.create');
    Route::post('store/{store}/voucher/store', [voucherController::class, 'store'])->name('vouchers.store');
    Route::delete('store/{store}/vouchers/{voucher}/delete', [VoucherController::class, 'destroy'])->name('vouchers.destroy');
    Route::get('stores/{store}/vouchers/{voucher}/edit', [VoucherController::class, 'edit'])->name('vouchers.edit');
    Route::post('store/{store}/vouchers/{voucher}/update', [VoucherController::class, 'update'])->name('vouchers.update');

    Route::resource('notifications', NotificationController::class)->only('index', 'destroy');
    Route::get("notifications/{notification}/read", [NotificationController::class, "read"])->name("notifications.read");
});


Route::group(['middleware' => 'guest'], function () {
    //Register & Login
    Route::get('register', [AuthController::class, 'register'])->name('register');
    Route::post('signup', [AuthController::class, 'signup'])->name('singup');
    Route::get('login', [AuthController::class, 'login'])->name('login');
    Route::post('signin', [AuthController::class, 'signin'])->name('signin');
});

app/Models/Store.php
<?php

namespace App\Models;

use App\Models\User;
use App\Models\Review;
use App\Models\Product;
use App\Models\Voucher;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Store extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'image',
        'about',
        'phone',
    ];

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    public function vouchers(): HasMany
    {
        return $this->hasMany(Voucher::class);
    }

    public function products(): HasMany
    {
        return $this->hasMany(Product::class);
    }

    public function reviews()
    {
        return $this->morphMany(Review::class, 'reviewable');
    }
}

app/Http/Controllers/StoreController.php
<?php

namespace App\Http\Controllers;

use App\Models\Store;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Storage;
use App\Http\Requests\CreateStoreRequest;
use App\Http\Requests\UpdateStoreRequest;
use Illuminate\Notifications\Notification;

class StoreController extends Controller
{
    public function index()
    {
        $user = Auth::user();

        $count = $user->notifications()->count();

        $stores = $user->stores()->simplePaginate();

        return view('stores/index', [
            'stores' => $stores,
            'user' => $user,
            'count' => $count,
        ]);
    }

    public function create()
    {
        $user = Auth::user();
        $count = $user->notifications()->count();

        return view('stores/create', [
            'count' => $count,
        ]);
    }

    public function store(CreateStoreRequest $request)
    {
        Auth::user()->stores()->create($request->validated());

        return to_route('stores.index');
    }

    public function edit(Store $store)
    {
        $user = Auth::user();
        $count = $user->notifications()->count();

        return view('stores/edit', [
            'store' => $store,
            'count' => $count,
        ]);
    }

    public function update(UpdateStoreRequest $request, Store $store)
    {
        $store->update($request->validated());

        return to_route('stores.index', [
            'store' => $store
        ]);
    }

    public function destroy(Store $store)
    {
        $store->delete();

        return to_route('stores.index');
    }
}

resources/views/stores/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>New store</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <?php if (!$errors->isEmpty()) { ?>
        <ul>
            <?php foreach ($errors->messages() as $key => $messages) { ?>
                <?php foreach ($messages as $message) { ?>
                    <li style="color: red"><?= $message ?></li>
                <?php } ?>
            <?php } ?>
        </ul>
    <?php } ?>
</head>
<body>
    <h1>New store</h1>
    <a href="{{ route('logout') }}">Logout</a> |
    <a href="{{ route('stores.index') }}">All stores</a> |
    <a href="{{ route('wallets.show', $wallet)  }}">Wallet</a> |
    <a href="{{ route('notifications.index')  }}">Notifacations</a> <span style="color: orange;">({{$count}})</span>
    <hr>
    <form action="{{ route('stores.store') }}" method="post" enctype="multipart/form-data">
        @csrf()

        <label for="name">Name</label>
        <input type="text" name="name" id="name">

        <label for="image">Image</label>
        <input type="file" name="image" id="image">

        <label for="phone">Phone</label>
        <input type="text" name="phone" id="phone">

        <label for="about">About</label>
        <textarea name="about" id="about" cols="30" rows="10"></textarea>

        <input type="submit" value="Create">
    </form>

</body>
</html>

resources/views/stores/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Edit store</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <?php if (!$errors->isEmpty()) { ?>
        <ul>
            <?php foreach ($errors->messages() as $key => $messages) { ?>
                <?php foreach ($messages as $message) { ?>
                    <li style="color: red"><?= $message ?></li>
                <?php } ?>
            <?php } ?>
        </ul>
    <?php } ?>
</head>
<body>
    <h1>Edit store</h1>
    <a href="{{ route('logout') }}">Logout</a> |
    <a href="{{ route('stores.index') }}">All stores</a> |
    <a href="{{ route('wallets.show', $wallet)  }}">Wallet</a>
    <a href="{{ route('notifications.index')  }}">Notifacations</a> <span style="color: orange;">({{$count}})</span>
    <hr>
    <form action="{{ route('stores.update', ['store' => $store['id']]) }}" method="post" enctype="multipart/form-data">
        @method('PUT')
        @csrf()

        <label for="name">Name</label>
        <input type="text" name="name" id="name"  value="{{ $store['name'] }}">

        <label for="image">Image</label>
        @if ($store->image != null)
            <img src="{{ Storage::url($store['image'])}}" alt="Store image" width="256" style="display: block; margin: 10px 0;">
        @endif
        <input type="file" name="image" id="image">

        <label for="phone">Phone</label>
        <input type="text" name="phone" id="phone" value="{{ $store['phone'] }}">

        <label for="about">About</label>
        <textarea name="about" id="about" cols="30" rows="10">{{ $store['about'] }}</textarea>

        <input type="submit" value="Update">
    </form>
</body>
</html>

resources/views/stores/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/dark.css">
    <title>stores</title>
    <style>
        .delete-btn {padding: 0 !important;display: inline !important;background: transparent !important;color: var(--links) !important;}
        .delete-btn:hover {text-decoration: underline;}
        .delete-form {display: inline !important;vertical-align: middle !important;}
    </style>
</head>
<body>
    <h1>{{ $user->name }} stores</h1>
    <a href="{{ route('stores.create') }}">New Store</a> |
    <a href="{{ route('wallets.show', $wallet)  }}">Wallet</a> |
    <a href="{{ route('notifications.index')  }}">Notifacations</a> <span style="color: orange;">({{$count}})</span> |
    <a href="{{ route('logout') }}">Logout</a>
    <hr>
    <table>
        <tr>
            <th width="20">Id</th>
            <th width="100">Name</th>
            <th>Image</th>
            <th>Phone</th>
            <th>About</th>
            <th>Actions</th>
        </tr>
        @foreach ($stores as $store)
            <tr>
                <td>{{ $store['id'] }}</td>
                <td>{{ $store['name'] }}</td>
                <td>
                    @if ($store->image != null)
                        <img src="{{ Storage::url($store['image']) }}" >
                    @endif
                </td>
                <td>{{ $store['phone'] }}</td>
                <td>{{ Str::limit($store['about'], 10) }}</td>
                <td>
                    <a href="{{ route('stores.edit', ['store' => $store]) }}">Edit</a> |
                    <a href="{{ route('products.index', ['store' => $store['id']]) }}">Open </a> |
                    <form onsubmit="return confirm('Are you sure?');" class="delete-form" action="{{route('stores.destroy', ['store' => $store['id']]) }}" method="POST">
                        @method('DELETE')
                        @csrf()
                        <input class="delete-btn" type="submit" value="Delete">
                    </form>
                </td>
            </tr>
        @endforeach
    </table>
    {{ $stores->links() }}
</body>
</html>